

function radius = CalRadius(ptn, w)

[ptn_h ptn_w] = size(ptn);

ptn_1 = [ptn; -ones(1, ptn_w)];     % This means Xn = -1

wio = w(:,1:(end-1));

d = abs(w*ptn_1);

r = zeros(ptn_h,ptn_w);

for i=1:ptn_h
    for k=1:ptn_w
        
        tmp_r = wio(i,:).*ptn(:,k)'*ptn(i,k);
        sr1= sort(tmp_r);
        sr = 2*sort(tmp_r);
        sr(1:end) = sr(end:-1:1); %descending order
        
        
        
        if( (w(i,:)*ptn_1(:,k)*ptn(i,k)) >=0 )
            r(i,k) = -1;
            for j=1:length(sr)
                if( sum(sr(1:j))>d(i,k) ) 
                    r(i,k) = j-1;
                    break;
                end
            end
            if( r(i,k) == -1 )
                r(i,k) = length(sr);
            end
        else
            r(i,k) = -2;
        end
        
    end
end

if any(any(r<0))
    r(find(r<0)) = 0;
end
radius = sum(sum(r));
%radius = r;

% for i=1:ptn_w
%     figure(i);
%     subplot(3,1,3);
%     bar(r(:,i));
%     title(strcat('The Radius of each bit of Pattern ',char(i+64), ' (ETAM)'));
%     axis([0 100 0 100]);
%     %xlabel('each bit(neuron)');
%     ylabel('Radius');
% end
