
function rec = CalRecovery(ptn, w)
% calculate Recovery pattern

	[ptn_h ptn_w] = size(ptn);
	
    rev_mtx = [-eye(ptn_h); zeros(1,ptn_h)];
    rev_mtx(find(rev_mtx==0))=1;
    
    rec = 0;
    
	for i=1:ptn_w
        tmp_ptn = [ptn(:,i); -1];
        ptn_grp = tmp_ptn*ones(1,ptn_h);
        ptn_grp_r = rev_mtx.*ptn_grp;
        ptn_grp_o = w*ptn_grp_r;
        ptn_grp(end,:)=[];    %clear -1
        ptn_grp_o(find(ptn_grp_o~=0)) = sign(ptn_grp_o(find(ptn_grp_o~=0)));
        ptn_grp_o(find(ptn_grp_o==0)) = ptn_grp(find(ptn_grp_o==0));
        
        %sum(~any(ptn_grp_o-ptn_rep))
        rec = rec + sum(~any(ptn_grp_o-ptn_grp(1:ptn_h,:)));
	end
    
    