
clear
clc;

load -ascii input.055
%load -ascii text_pattern.txt;
%input = text_pattern;
%load -ascii input.m.105;

[input_dec_h input_dec_w] = size(input);

exam_all = 1;

n = 5;
p = 5;
experiment = 10;

dec_input = input;
input = zeros(size(dec_input,1),n);
for i=1:input_dec_h
    input(i,:) = dec2binvec(dec_input(i),n); 
end
clear dec_input;

sp = 0;
All_W =[];     %store all experiment's weight
fid_w = fopen('w.dat','w');

%%%%%%%%%%%%%%%%%%%%%%%%%% recovery %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
recovery = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%% recovery %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if exam_all==1
	next = [];
	fid = fopen('data','w');
	all_num = (2^n);
	all_seq = zeros(all_num,n);
	for i=1:all_num
        all_seq(i,:) = dec2binvec(i-1,n); %minus ascii code of zero '48'
	end
	all_seq(find(all_seq==0)) = -1;
	all_seq_th = [all_seq -ones(all_num,1)]';   % all binary sequence with Xn = -1
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



total_time = 0;
total_r = 0;

for set=1:p:(p*experiment)
    
    input(find(input==0))=-1;
	ptn = input((set:(set+p-1)),:)';
    tic
    w = ETLM_train( ptn , n );
    
    [bitUp bitUn] = CalbitU(ptn);
    
    
    %radius(ept,:) = CalRadius(ptn,w);
    
    %total_r = total_r+CalRadius(ptn,w);
    %total_r = total_r+CalErrorTolerance(ptn,w,0);
    total_time = total_time + toc;
    
    sp = sp + CalSP(ptn,w);
    recovery = recovery + CalRecovery(ptn,w);
    
    %enum all possible
    if(exam_all==1)
        tmp_next = (w*all_seq_th)';
        tmp_next(find(tmp_next~=0)) = sign(tmp_next(find(tmp_next~=0)));
        tmp_next(find(tmp_next==0)) = all_seq(find(tmp_next==0));
	
        tmp_next(find(tmp_next==-1))=0;
        
        tmp_next_o = zeros(all_num,1);
        
        for i=1:500000:all_num
            upp = min(i+500000-1,all_num);
            tmp_next_o = binvec2dec(tmp_next(i:upp,:));
	
            tmp_next_o = tmp_next_o(1:3:3*(upp-i+1));
         
            fprintf(fid,'%d\n',tmp_next_o);
        end
    end
    
    
    All_W = [All_W; w]; %append the weight to All_W
end

%radius
sp
recovery
%total_r
total_time
%save -ascii 'w.dat' All_W


for i=1:size(All_W,1)
    for j=1:size(All_W,2)
        fprintf(fid_w,'%.10f\n',All_W(i,j));
    end
end

if(exam_all==1)
    fclose(fid);
end
fclose(fid_w);

